Preço do CRM de vendas - POST /api/sn_csm_pricing/
Permite que os chamadores calculem o preço dos produtos especificados na carga de solicitação. As configurações de preço incluídas na carga determinam e controlam o fluxo de execução do Mecanismo de preços, como se validações, ajustes ou rollups devem ser aplicadas.
Formato de URL
URL com controle de versão: /api/sn_csm_pricing//pricingengine/computePrice
URL padrão:
Parâmetros de solicitação compatíveis
| Nome | Descrição |
|---|---|
| Nenhum(a) |
| Nome | Descrição |
|---|---|
| Nenhum(a) |
| Nome | Descrição |
|---|---|
| cabeçalho | Necessário. Contém detalhes no nível da transação, itens de linha, moeda, lista de preços e data da transação. Tipo de dados: Objeto |
| header.source_system | Necessário. O sistema que inicia a solicitação. Tipo de dados: Cadeia de caracteres Exemplo: |
| requesting_record_id | Necessário. Identificador exclusivo para esta solicitação. Tipo de dados: Cadeia de caracteres Exemplo: |
| moeda.cabeçalho | Necessário. Código da moeda para preço. Compatível somente com moedas da ServiceNow. Tipo de dados: Cadeia de caracteres Exemplo: |
| header.transaction_date | Necessário. A data e hora da transação. Formato: Formato: Valor Glide_date_time, como Tipo de dados: datetime Exemplo: |
| lista de preços.cabeçalho | Necessário. O ID da lista de preços padrão a ser usado para a transação. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems | Necessário. Matriz de objetos de item de linha detalhando produtos, quantidades e informações de preço. |
| Items.lineItems[].line_id | Necessário. Identificador exclusivo para este item de linha. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].lista de preços | Necessário. ID da lista de preços para este item de linha. Tipo de dados: Cadeia de caracteres Exemplo: |
| Header.lineItems[].product_offering | Necessário. ID da oferta de produto para este item de linha. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].Periodicidade | Identifica a frequência. Os valores possíveis são mensal , anualmente , ou nulo/indefinido.Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].Quantidade | Necessário. Quantidade do produto. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].unit_of_measure | Necessário. ID da unidade de medida. Tipo de dados: Cadeia de caracteres Exemplo: |
| Header.lineItems[].transaction_date | Necessário. Data da transação específica para este item de linha. Formato: Valor Glide_date_time Tipo de dados: datetime Exemplo: |
| Header.lineItems[].account_tier | Nível de conta opcional (por exemplo, "ouro") para a lógica de preços. Se account_tier for uma variável de contexto usada em matrizes de regras. Tipo de dados: Cadeia de caracteres |
| Items.lineItems[].Selecionado | Indica se o item de linha está selecionado em um cenário de configurador. Aplicável somente para linhas secundárias no pacote. Tipo de dados: Booliano Exemplo: |
| Header.lineItems[].top_product_offer | Identificador do produto de nível superior em um pacote de configuração. Tipo de dados: Cadeia de caracteres Exemplo: |
| Header.lineItems[].parent_product_offer | Identificador do produto primário em um item de linha do pacote. Tipo de dados: Cadeia de caracteres Exemplo: |
| configurações | Necessário. Contém configurações e opções do mecanismo de preços. Tipo de dados: Objeto |
| settings.pricing_elements | Necessário. Lista separada por vírgulas de elementos a serem retornados. Tipo de dados: Cadeia de caracteres Exemplo: |
| settings.disable_validation | Se as verificações de validação devem ser desabilitadas na solicitação. Tipo de dados: Booliano Exemplo: |
| settings.config_lines_expanded | Indica se todas as linhas do pacote foram enviadas na solicitação. No momento, para o configurador, esperamos que todas as linhas sejam enviadas para cada chamada de preços proveniente do configurador. Tipo de dados: Booliano Exemplo: |
| escopo.configurações | Escopo do preço. Tipo de dados: Cadeia de caracteres Exemplo: |
| settings.config_top_line_identifier | O ID da linha do produto de nível superior na configuração. Tipo de dados: Cadeia de caracteres Exemplo: |
| settings.use_external_code | Indica se o sistema executa pesquisa de código externo. Tipo de dados: Booliano Exemplo: |
Cabeçalhos
Os cabeçalhos de solicitação e resposta a seguir se aplicam somente a esta ação HTTP ou se aplicam a esta ação de maneira distinta. Para obter uma lista de cabeçalhos gerais usados na REST API, consulte Cabeçalhos da REST API compatíveis .
| Cabeçalho | Descrição |
|---|---|
| Aceitar | Formato de dados do corpo da resposta. Tipos compatíveis: application/jsonou application/xml. Padrão: application/json |
| Cabeçalho | Descrição |
|---|---|
| Nenhum(a) |
Códigos de status
Os seguintes códigos de status se aplicam a esta ação HTTP. Para obter uma lista de possíveis códigos de status usados na REST API, consulte REST API códigos de resposta HTTP .
| Código de status | Descrição |
|---|---|
| 200 | Bem-sucedido. A solicitação foi processada com sucesso. |
Parâmetros do corpo da resposta (JSON ou XML)
| Nome | Descrição |
|---|---|
| moeda.cabeçalho | Código da moeda usado na resposta de preços. Semelhante ao enviado na solicitação. Tipo de dados: Cadeia de caracteres Exemplo: |
| cabeçalho.costbook | Identificador do livro de custos usado para preços. Tipo de dados: Cadeia de caracteres (sys_id) |
| Items.lineItems | Contém detalhes de preço para cada item de linha. Tipo de dados: Matriz<Object> |
| Items.lineItems[].line_id | Identificador do item de linha. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].status | Status do cálculo de preços do item de linha. Opções válidas:
Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].base_price | Preço-base antes dos ajustes. Tipo de dados: Objeto |
| Items.lineItems[].list_price | Preço de lista, que é o preço base e os ajustes de atributo incluídos. Tipo de dados: Objeto |
| Items.lineItems[].lista de preços | Referência da lista de preços. Tipo de dados: Cadeia de caracteres (sys_id) |
| Items.lineItems[].Quantidade | Quantidade enviada como parte da solicitação. Tipo de dados: Cadeia de caracteres Exemplo: |
| Items.lineItems[].price_list_line | Referência de linha da lista de preços. Tipo de dados: Cadeia de caracteres (sys_id) Exemplo: |
| Header.lineItems[].product_offering | Referência de oferta de produto. Tipo de dados: Cadeia de caracteres (sys_id) Exemplo: |
| Header.lineItems[].one_time_price | Preço único do produto, preço líquido unitário * quantidade. Tipo de dados: Objeto |
| Header.lineItems[].monthly_recurring_price | Preço recorrente mensal do produto, incluindo todas as quantidades. Tipo de dados: Objeto |
| Header.lineItems[].annual_recurring_price | Preço recorrente anual do produto, incluindo todas as quantidades. Tipo de dados: Objeto |
| Items.lineItems[].unit_net_price | Preço líquido por unidade após ajustes automáticos. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_net_price | [Preço único mais (preço recorrente mensal * termo)] mais (se linha primária) Soma de todos os CNP para linhas secundárias imediatas e grandes Tipo de dados: Objeto |
| Header.lineItems[].cumulative_one_time_price | Para Secundário- Preço único para o item de linha. Para item de linha primário - Preço único para o item de linha mais preço único para todos os itens de linha secundários e secundários principais. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_monthly_recurring_price | Se o método de preço for recorrente. Valor recorrente mensal para a soma da linha mais (se linha primária) de todo o preço recorrente mensal das linhas secundárias. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_annual_recurring_price | Se o método de preço for recorrente. Preço recorrente mensal cumulativo * 12. Tipo de dados: Objeto |
| Items.lineItems[].unit_adjustment | Ajuste de preço aplicado por unidade. Tipo de dados: Objeto |
| Header.lineItems[].term_month | Duração do prazo em meses. Tipo de dados: Objeto |
| Items.lineItems[].Custo | Custo unitário do produto. Tipo de dados: Objeto |
| Header.lineItems[].unit_margin_amount | Valor da margem de lucro por unidade. Tipo de dados: Objeto |
| Items.lineItems[].unit_margin_percentage | Percentual da margem de lucro por unidade. Tipo de dados: Objeto |
| Header.lineItems[].one_time_cost | Custo único do produto, incluindo todas as quantidades. Tipo de dados: Objeto |
| Header.lineItems[].monthly_recurring_cost | Custo recorrente mensal do produto, incluindo todas as quantidades. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_one_time_cost | Para Secundário - Custo único para o item de linha. Para item de linha primário - Custo único para o item de linha mais custo único para todos os itens de linha secundários e secundários principais. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_monthly_recurring_cost | Se o método de preço for recorrente. Soma do custo recorrente mensal da linha mais (se linha primária) de todo o custo recorrente mensal das linhas secundárias. Tipo de dados: Objeto |
| Header.lineItems[].cumulative_net_cost | [Custo único mais (custo recorrente mensal * termo)] mais (se linha primária) Soma de todos os CNC para linhas secundárias imediatas e grandes Tipo de dados: Objeto |
| Header.lineItems[].cumulative_margin_percentage | Porcentagem de margem geral. Tipo de dados: Objeto |
| status.cabeçalho | Status da solicitação de preço geral. As opções válidas são:
Tipo de dados: Cadeia de caracteres Exemplo: |
| total_monthly_recorrente_price | Preço recorrente mensal agregado. Tipo de dados: Objeto |
| header.total_annual_recorrente_price | Preço recorrente anual agregado. Tipo de dados: Objeto |
| total_amount.cabeçalho | Valor total da transação. Tipo de dados: Objeto |
| total_one_time_price | Preço único agregado. Tipo de dados: Objeto |
| total_one_time_cost | Custo único agregado. Tipo de dados: Objeto |
| total_monthly_cost | Custo mensal agregado. Tipo de dados: Objeto |
| total_cost | Custo total (único ou recorrente). Tipo de dados: Objeto |
| total_one_time_margin | Margem total de cobranças únicas. Tipo de dados: Objeto |
| total_monthly_margin | Margem total das cobranças mensais. Tipo de dados: Objeto |
| total_margin_amount | Valor total da margem de lucro. Tipo de dados: Objeto |
| total_one_time_margin_percentage | Percentual de margem para cobranças únicas. Tipo de dados: Objeto |
| total_monthly_margin_percentage | Percentual de margem para cobranças mensais. Tipo de dados: Objeto |
| total_margin_percentage | Porcentagem de margem geral. Tipo de dados: Objeto |
| settings.pricing_elements | Elementos incluídos na resposta de preços (PREÇO, CUSTO, NET_PRICE etc.). Tipo de dados: Cadeia de caracteres |
| settings.pricing_context_id | Identificador da sessão de preços quando o escopo é o configurador. Tipo de dados: Cadeia de caracteres |
Uso de exemplo
- Calculando um preço para um único produto
- Calcule preços para vários produtos com acúmulos de cabeçalho
- Inicie uma sessão de configuração do produto
- Atualizar uma configuração de produto (mudar uma opção de característica)
Calcule o preço de um único produto
Este exemplo demonstra um cálculo de preço básico para uma única oferta de produto. A API é chamada com um item de linha e a solicitação especifica que o PREÇO, CUSTO, NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS e AJUSTES devem ser calculados e retornados. Esta é uma solicitação básica para obter o preço de um item individual sem configurações ou ajustes complexos.
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"periodicity" : "",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "CONNECTEDC1100"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"disable_validation": true
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "CONNECTEDC1100",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "",
"price_list_line": "3e93e785d07a7910f8770dbf976be1ee",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
}
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Calcule preços para vários produtos com acúmulos de cabeçalho
Este exemplo mostra como enviar uma lista de vários produtos distintos a serem precificados em uma única transação. Uma diferença importante nesta solicitação é a inclusão que envia vários produtos na mesma solicitação. Isso instrui o mecanismo de preços a calcular o preço individual de cada item de linha e a calcular e retornar os totais agregados de toda a solicitação.
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "Test Source System",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"top_product_offer": "db61dd9fd0a63110f8770dbf976be19c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"periodicity" : "",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "CONNECTEDC1000"
},
{
"top_product_offer": "9b61dd9fd0a63110f8770dbf976be1c6",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "9b61dd9fd0a63110f8770dbf976be1c6",
"periodicity" : "annually",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "AUTOCOLLIS1001"
},
{
"top_product_offer": "9361dd9fd0a63110f8770dbf976be1c4",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "9361dd9fd0a63110f8770dbf976be1c4",
"periodicity" : "annually",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "WIFIHOTSPOT1002"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"disable_validation": true
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "CONNECTEDC1000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "3e93e785d07a7910f8770dbf976be1ee",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"top_product_offer": "db61dd9fd0a63110f8770dbf976be19c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "AUTOCOLLIS1001",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"list_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "4dc32f85d07a7910f8770dbf976be197",
"product_offering": "9b61dd9fd0a63110f8770dbf976be1c6",
"top_product_offer": "9b61dd9fd0a63110f8770dbf976be1c6",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "20.8333",
"displayValue": "$20.8333"
},
"annual_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"unit_net_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "20.8333",
"displayValue": "$20.8333"
},
"cumulative_annual_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "250.0000",
"displayValue": "$250.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "WIFIHOTSPOT1002",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"list_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "3ff3ef85d07a7910f8770dbf976be1ea",
"product_offering": "9361dd9fd0a63110f8770dbf976be1c4",
"top_product_offer": "9361dd9fd0a63110f8770dbf976be1c4",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "8.3333",
"displayValue": "$8.3333"
},
"annual_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"unit_net_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "8.3333",
"displayValue": "$8.3333"
},
"cumulative_annual_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "100.0000",
"displayValue": "$100.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "29.1666",
"displayValue": "$29.1666"
},
"total_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price": {
"value": "350.0000",
"displayValue": "$350.00"
},
"total_annual_recurring_price_v1": {
"value": "350.0000",
"displayValue": "$350.00"
},
"total_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount_v1": {
"value": "350.0000",
"displayValue": "$350.00"
},
"total_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin": {
"value": "29.1666",
"displayValue": "$29.1666"
},
"total_margin_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
}
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Inicie uma sessão de configuração do produto
Este exemplo demonstra como iniciar uma sessão de configuração de produto com estado. Isso é usado para produtos complexos que são vendidos como um pacote com vários componentes e opções selecionáveis pelo usuário. Ao definir o escopo como "configurador", dizemos ao mecanismo de preços para criar uma sessão persistente. O mecanismo processa toda a hierarquia do produto, calcula os preços iniciais e retorna um pricing_context_id exclusivo.
pricing_context_id deve ser capturado e enviado em todas as solicitações subsequentes para esta configuração (por exemplo, ao mudar uma quantidade ou selecionar uma opção) para manter o estado da sessão.Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "26d07c3211707110f877366201dea60c",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"periodicity" : "",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "HOMEAUTOMA2000"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "fe5d203e11307110f877366201dea631",
"periodicity" : "",
"quantity": "3",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "DOORSENSOR1001"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"characteristics": [
{
"characteristic": "4f31999fd0a63110f8770dbf976be178",
"characteristic_option": "0b31999fd0a63110f8770dbf976be179"
}
],
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "HOMEAUTOMA1002"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "376111dfd0a63110f8770dbf976be140",
"periodicity" : "monthly",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "BASICMONIT1003"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "e2619d9fd0a63110f8770dbf976be1ec",
"periodicity" : "monthly",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "PREMMONIT2004"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "3b6111dfd0a63110f8770dbf976be147",
"periodicity" : "monthly",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "ULTIMONIT1005"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "1761dd9fd0a63110f8770dbf976be196",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "INDOORCAM1006"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "6f6111dfd0a63110f8770dbf976be100",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "OUTCAMERA1007"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "1b20347e11307110f877366201dea67f",
"periodicity" : "",
"quantity": "3",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "WINSENSOR1008"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"disable_validation": true,
"scope": "configurator",
"config_top_line_identifier": "HOMEAUTOMA2000",
"config_lines_expanded": false
}
}' \
--user 'username:password'
Resposta de exemplo:
O resultado a seguir mostra que o status da solicitação é Bem-sucedido.
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "HOMEAUTOMA2000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "d6792b8dd07a7910f8770dbf976be1f8",
"product_offering": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"cumulative_one_time_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"cumulative_monthly_recurring_price": {
"value": "105.0000",
"displayValue": "$105.00"
},
"cumulative_annual_recurring_price": {
"value": "1260.0000",
"displayValue": "$1,260.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "DOORSENSOR1001",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "10.0000",
"displayValue": "$10.00"
},
"list_price": {
"value": "10.0000",
"displayValue": "$10.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "3",
"price_list_line": "2ec2a745d07a7910f8770dbf976be159",
"product_offering": "fe5d203e11307110f877366201dea631",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "8.0000",
"displayValue": "$8.00"
},
"cumulative_net_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"cumulative_one_time_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-2.0000",
"displayValue": "($2.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -2.0,
"displayValue": "($2.00)"
},
"adjustment_amount_total": {
"value": -6.0,
"displayValue": "($6.00)"
},
"adjustment_description": {
"displayValue": "door sensor bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 8.0,
"displayValue": "$8.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -6.0,
"displayValue": "($6.00)"
}
]
},
{
"line_id": "HOMEAUTOMA1002",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"list_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "fe912705d07a7910f8770dbf976be147",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_net_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_one_time_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-20.0000",
"displayValue": "($20.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -20.0,
"displayValue": "($20.00)"
},
"adjustment_amount_total": {
"value": -20.0,
"displayValue": "($20.00)"
},
"adjustment_description": {
"displayValue": "home automation hub bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 80.0,
"displayValue": "$80.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -20.0,
"displayValue": "($20.00)"
}
]
},
{
"line_id": "BASICMONIT1003",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "30.0000",
"displayValue": "$30.00"
},
"list_price": {
"value": "30.0000",
"displayValue": "$30.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "bc53e785d07a7910f8770dbf976be1e7",
"product_offering": "376111dfd0a63110f8770dbf976be140",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"annual_recurring_price": {
"value": "300.0000",
"displayValue": "$300.00"
},
"unit_net_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_annual_recurring_price": {
"value": "300.0000",
"displayValue": "$300.00"
},
"unit_adjustment": {
"value": "-5.0000",
"displayValue": "($5.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "25.0000",
"displayValue": "$25.00"
},
"total_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "6e1c03d653dd91105c0eddeeff7b1232",
"displayValue": "MARKDOWN_AMT"
},
"adjustment_value": {
"value": 5.0,
"displayValue": "5"
},
"adjustment_amount": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_amount_total": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_description": {
"displayValue": "basic monitoring bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 25.0,
"displayValue": "$25.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -5.0,
"displayValue": "($5.00)"
}
]
},
{
"line_id": "PREMMONIT2004",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"list_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "a663a785d07a7910f8770dbf976be115",
"product_offering": "e2619d9fd0a63110f8770dbf976be1ec",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"annual_recurring_price": {
"value": "420.0000",
"displayValue": "$420.00"
},
"unit_net_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"cumulative_annual_recurring_price": {
"value": "420.0000",
"displayValue": "$420.00"
},
"unit_adjustment": {
"value": "-5.0000",
"displayValue": "($5.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "35.0000",
"displayValue": "$35.00"
},
"total_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "6e1c03d653dd91105c0eddeeff7b1232",
"displayValue": "MARKDOWN_AMT"
},
"adjustment_value": {
"value": 5.0,
"displayValue": "5"
},
"adjustment_amount": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_amount_total": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_description": {
"displayValue": "premium monitoring bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 35.0,
"displayValue": "$35.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -5.0,
"displayValue": "($5.00)"
}
]
},
{
"line_id": "ULTIMONIT1005",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"list_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "72736f85d07a7910f8770dbf976be162",
"product_offering": "3b6111dfd0a63110f8770dbf976be147",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "45.0000",
"displayValue": "$45.00"
},
"annual_recurring_price": {
"value": "540.0000",
"displayValue": "$540.00"
},
"unit_net_price": {
"value": "45.0000",
"displayValue": "$45.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "45.0000",
"displayValue": "$45.00"
},
"cumulative_annual_recurring_price": {
"value": "540.0000",
"displayValue": "$540.00"
},
"unit_adjustment": {
"value": "-5.0000",
"displayValue": "($5.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "45.0000",
"displayValue": "$45.00"
},
"total_recurring_price": {
"value": "45.0000",
"displayValue": "$45.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "6e1c03d653dd91105c0eddeeff7b1232",
"displayValue": "MARKDOWN_AMT"
},
"adjustment_value": {
"value": 5.0,
"displayValue": "5"
},
"adjustment_amount": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_amount_total": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_description": {
"displayValue": "ultimate monitoring bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 45.0,
"displayValue": "$45.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -5.0,
"displayValue": "($5.00)"
}
]
},
{
"line_id": "INDOORCAM1006",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"list_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "81332f45d07a7910f8770dbf976be14e",
"product_offering": "1761dd9fd0a63110f8770dbf976be196",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_net_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_one_time_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-7.0000",
"displayValue": "($7.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -7.0,
"displayValue": "($7.00)"
},
"adjustment_amount_total": {
"value": -7.0,
"displayValue": "($7.00)"
},
"adjustment_description": {
"displayValue": "indoor camera bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 28.0,
"displayValue": "$28.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -7.0,
"displayValue": "($7.00)"
}
]
},
{
"line_id": "OUTCAMERA1007",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"list_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "9a136f45d07a7910f8770dbf976be1b4",
"product_offering": "6f6111dfd0a63110f8770dbf976be100",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_net_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_one_time_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-8.0000",
"displayValue": "($8.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -8.0,
"displayValue": "($8.00)"
},
"adjustment_amount_total": {
"value": -8.0,
"displayValue": "($8.00)"
},
"adjustment_description": {
"displayValue": "outdoor camera bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 32.0,
"displayValue": "$32.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -8.0,
"displayValue": "($8.00)"
}
]
},
{
"line_id": "WINSENSOR1008",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "15.0000",
"displayValue": "$15.00"
},
"list_price": {
"value": "15.0000",
"displayValue": "$15.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "3",
"price_list_line": "91f26b45d07a7910f8770dbf976be19b",
"product_offering": "1b20347e11307110f877366201dea67f",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "12.0000",
"displayValue": "$12.00"
},
"cumulative_net_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"cumulative_one_time_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-3.0000",
"displayValue": "($3.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -3.0,
"displayValue": "($3.00)"
},
"adjustment_amount_total": {
"value": -9.0,
"displayValue": "($9.00)"
},
"adjustment_description": {
"displayValue": "window sensor bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 12.0,
"displayValue": "$12.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -9.0,
"displayValue": "($9.00)"
}
]
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_monthly_recurring_price_v1": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_annual_recurring_price": {
"value": "1260.0000",
"displayValue": "$1,260.00"
},
"total_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_amount_v1": {
"value": "305.0000",
"displayValue": "$305.00"
},
"total_one_time_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_monthly_margin": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_margin_amount": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_one_time_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_monthly_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
}
},
"settings": {
"pricing_context_id": "7049E245A667EABB226B16A2190FB92E",
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Atualizar uma configuração de produto (mudar uma opção de característica)
Este exemplo demonstra como atualizar uma sessão de configuração de produto ativa alterando uma opção selecionável pelo usuário (característica). Esta é uma ação comum em um configurador de produto, como mudar uma cor, tamanho ou recurso.
Pré-requisito: Você precisa incluir o. pricing_context_id que é retornado ao iniciar um sessão de configuração do produto . Isso informa ao mecanismo de preços qual sessão atualizar.
Observação: A matriz lineItems só precisa conter o item específico que está sendo modificado, não é necessário enviar a hierarquia inteira do produto novamente.
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"periodicity": "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"characteristics": [
{
"characteristic": "4f31999fd0a63110f8770dbf976be178",
"characteristic_option": "8331999fd0a63110f8770dbf976be179"
}
],
"transaction_date": "2025-08-28 22:46:39",
"selected": true,
"line_id": "HOMEAUTOMA1002"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"pricing_context_id": "7049E245A667EABB226B16A2190FB92E",
"disable_validation": true,
"scope": "configurator",
"config_top_line_identifier": "HOMEAUTOMA2000",
"config_lines_expanded": false
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "HOMEAUTOMA1002",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"list_price": {
"value": "120.0000",
"displayValue": "$120.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "fe912705d07a7910f8770dbf976be147",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "96.0000",
"displayValue": "$96.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "96.0000",
"displayValue": "$96.00"
},
"cumulative_net_price": {
"value": "96.0000",
"displayValue": "$96.00"
},
"cumulative_one_time_price": {
"value": "96.0000",
"displayValue": "$96.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-24.0000",
"displayValue": "($24.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "d88bc79653dd91105c0eddeeff7b12c1",
"displayValue": "MARKUP_AMT"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "$20.00"
},
"adjustment_amount": {
"value": 20.0,
"displayValue": "$20.00"
},
"adjustment_amount_total": {
"value": 20.0,
"displayValue": "$20.00"
},
"adjustment_description": {
"displayValue": "Attribute Adjustments"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": null
},
"adjustment_basis": {
"value": null
},
"price_point": {
"value": "list_price"
},
"pricing_plan_step": {
"value": "8bb61272ffe722101fb14ad013cb149d"
},
"running_price": {
"value": 120.0,
"displayValue": "$120.00"
}
},
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -24.0,
"displayValue": "($24.00)"
},
"adjustment_amount_total": {
"value": -24.0,
"displayValue": "($24.00)"
},
"adjustment_description": {
"displayValue": "home automation hub bundle discount"
},
"adjustment_sequence_id": {
"value": 2.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 96.0,
"displayValue": "$96.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "list_price",
"value": 20.0,
"displayValue": "$20.00"
},
{
"pricePoint": "net_price",
"value": -24.0,
"displayValue": "($24.00)"
}
]
},
{
"line_id": "HOMEAUTOMA2000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "d6792b8dd07a7910f8770dbf976be1f8",
"product_offering": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "216.0000",
"displayValue": "$216.00"
},
"cumulative_one_time_price": {
"value": "216.0000",
"displayValue": "$216.00"
},
"cumulative_monthly_recurring_price": {
"value": "105.0000",
"displayValue": "$105.00"
},
"cumulative_annual_recurring_price": {
"value": "1260.0000",
"displayValue": "$1,260.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_monthly_recurring_price_v1": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_annual_recurring_price": {
"value": "1260.0000",
"displayValue": "$1,260.00"
},
"total_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount": {
"value": "216.0000",
"displayValue": "$216.00"
},
"total_amount_v1": {
"value": "321.0000",
"displayValue": "$321.00"
},
"total_one_time_price": {
"value": "216.0000",
"displayValue": "$216.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "216.0000",
"displayValue": "$216.00"
},
"total_monthly_margin": {
"value": "105.0000",
"displayValue": "$105.00"
},
"total_margin_amount": {
"value": "216.0000",
"displayValue": "$216.00"
},
"total_one_time_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_monthly_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
}
},
"settings": {
"pricing_context_id": "7049E245A667EABB226B16A2190FB92E",
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Atualizar uma configuração de produto (desmarcar um produto)
Este exemplo demonstra como atualizar uma configuração de produto ativa desmarcando ou removendo um produto do pacote. Isso é obtido enviando uma solicitação para o item de linha específico com seus selecionado sinalizador definido como falso .
Assim como no caso de uso anterior, esta solicitação deve incluir o correto pricing_context_id para garantir que a mudança seja aplicada à sessão correta. O mecanismo de preços recalculará todos os preços do pacote inteiro com esse item removido, o que pode afetar os descontos e acúmulos gerais.
Pré-requisito: Você precisa incluir o. pricing_context_id que é retornado ao iniciar um sessão de configuração do produto . Isso informa ao mecanismo de preços qual sessão atualizar.
Observação: A matriz lineItems só precisa conter o item específico que está sendo modificado, não é necessário enviar a hierarquia inteira do produto novamente.
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "3b6111dfd0a63110f8770dbf976be147",
"quantity": "1",
"periodicity": "monthly",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"selected": false,
"line_id": "ULTIMONIT1005"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"costbook": "a3042cdce405c210f8773750028d6f72",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"pricing_context_id": "7049E245A667EABB226B16A2190FB92E",
"disable_validation": true,
"scope": "configurator",
"config_top_line_identifier": "HOMEAUTOMA2000",
"config_lines_expanded": false
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"costbook": "a3042cdce405c210f8773750028d6f72",
"lineItems": [
{
"line_id": "ULTIMONIT1005",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"list_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "72736f85d07a7910f8770dbf976be162",
"product_offering": "3b6111dfd0a63110f8770dbf976be147",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"annual_recurring_price": {
"value": "600.0000",
"displayValue": "$600.00"
},
"unit_net_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_acv": {
"value": "600.0000",
"displayValue": "$600.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"cumulative_annual_recurring_price": {
"value": "600.0000",
"displayValue": "$600.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "50.0000",
"displayValue": "$50.00"
},
"total_recurring_price": {
"value": "50.0000",
"displayValue": "$50.00"
},
"total_new_amount": {
"value": 0,
"displayValue": null
},
"total_upsell_downsell_amount": {
"value": 0,
"displayValue": null
},
"total_renewal_amount": {
"value": 0,
"displayValue": null
},
"pricingAdjustments": [],
"total_adjustment_amount": [],
"cost": {
"value": "25.0000",
"displayValue": "$25.00"
},
"unit_margin_amount": {
"value": "25.0000",
"displayValue": "$25.00"
},
"unit_margin_percentage": {
"value": "50.0000",
"displayValue": "50.0000"
},
"one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_cost": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_cost": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_net_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
}
},
{
"line_id": "HOMEAUTOMA2000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "d6792b8dd07a7910f8770dbf976be1f8",
"product_offering": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "270.0000",
"displayValue": "$270.00"
},
"cumulative_acv": {
"value": "270.0000",
"displayValue": "$270.00"
},
"cumulative_one_time_price": {
"value": "270.0000",
"displayValue": "$270.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_new_amount": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_upsell_downsell_amount": {
"value": 0,
"displayValue": null
},
"total_renewal_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": [],
"cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_margin_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_margin_percentage": {
"value": "0.0000",
"displayValue": "0.0000"
},
"one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_cost": {
"value": "130.0000",
"displayValue": "$130.00"
},
"cumulative_monthly_recurring_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_cost": {
"value": "130.0000",
"displayValue": "$130.00"
},
"cumulative_margin_percentage": {
"value": "51.8519",
"displayValue": "51.8519"
}
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_acv": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_amount_v1": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_one_time_price": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_one_time_cost": {
"value": "130.0000",
"displayValue": "$130.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "130.0000",
"displayValue": "$130.00"
},
"total_one_time_margin": {
"value": "140.0000",
"displayValue": "$140.00"
},
"total_monthly_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_amount": {
"value": "140.0000",
"displayValue": "$140.00"
},
"total_one_time_margin_percentage": {
"value": "51.8519",
"displayValue": "$51.8519"
},
"total_monthly_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_percentage": {
"value": "51.8519",
"displayValue": "$51.8519"
},
"total_upsell_downsell_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_renewal_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_new_amount": {
"value": "270.0000",
"displayValue": "$270.00"
},
"total_new_amount_acv": {
"value": "270.0000",
"displayValue": "$270.00"
}
},
"settings": {
"pricing_context_id": "7E362E4CEDC0C3F684D346ED7A83D47E",
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Preço sem estado para uma transação de várias linhas
Este exemplo demonstra como precificar uma transação completa de várias linhas em uma única chamada de API. A solicitação inclui uma combinação de produtos autônomos e um pacote de produtos.
Ao incluir HEADER_ROLLUPS em pricing_elements, a API calculará o preço de cada item de linha individual e também retornará o total geral agregado de toda a transação no cabeçalho.
Exemplo: "PRICING_ELEMENTS": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"top_product_offer": "db61dd9fd0a63110f8770dbf976be19c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"periodicity" : "",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "CONNECTEDC1000"
},
{
"top_product_offer": "9b61dd9fd0a63110f8770dbf976be1c6",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "9b61dd9fd0a63110f8770dbf976be1c6",
"periodicity" : "annually",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "AUTOCOLLIS1001"
},
{
"top_product_offer": "9361dd9fd0a63110f8770dbf976be1c4",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "9361dd9fd0a63110f8770dbf976be1c4",
"periodicity" : "annually",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "WIFIHOTSPOT1002"
},
{
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "26d07c3211707110f877366201dea60c",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"periodicity" : "",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "HOMEAUTOMA2000"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "fe5d203e11307110f877366201dea631",
"periodicity" : "",
"quantity": "3",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "DOORSENSOR1001"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"characteristics": [
{
"characteristic": "4f31999fd0a63110f8770dbf976be178",
"characteristic_option": "0b31999fd0a63110f8770dbf976be179"
}
],
"transaction_date": "2025-08-28 22:46:39",
"line_id": "HOMEAUTOMA1002"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "376111dfd0a63110f8770dbf976be140",
"periodicity" : "monthly",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "BASICMONIT1003"
},
{
"parent_product_offer": "26d07c3211707110f8770dbf976be122",
"product_offering": "e2619d9fd0a63110f8770dbf976be1ec",
"periodicity" : "monthly",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "PREMMONIT2004"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "1761dd9fd0a63110f8770dbf976be196",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "INDOORCAM1006"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "6f6111dfd0a63110f8770dbf976be100",
"periodicity" : "",
"quantity": "1",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "OUTCAMERA1007"
},
{
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"pricelist": "19d29513d0e63110f8770dbf976be122",
"product_offering": "1b20347e11307110f877366201dea67f",
"periodicity" : "",
"quantity": "3",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2025-08-28 22:46:39",
"line_id": "WINSENSOR1008"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"disable_validation": true
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "CONNECTEDC1000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "3e93e785d07a7910f8770dbf976be1ee",
"product_offering": "db61dd9fd0a63110f8770dbf976be19c",
"top_product_offer": "db61dd9fd0a63110f8770dbf976be19c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "AUTOCOLLIS1001",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"list_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "4dc32f85d07a7910f8770dbf976be197",
"product_offering": "9b61dd9fd0a63110f8770dbf976be1c6",
"top_product_offer": "9b61dd9fd0a63110f8770dbf976be1c6",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "20.8333",
"displayValue": "$20.8333"
},
"annual_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"unit_net_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "20.8333",
"displayValue": "$20.8333"
},
"cumulative_annual_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "250.0000",
"displayValue": "$250.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "250.0000",
"displayValue": "$250.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "WIFIHOTSPOT1002",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"list_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "3ff3ef85d07a7910f8770dbf976be1ea",
"product_offering": "9361dd9fd0a63110f8770dbf976be1c4",
"top_product_offer": "9361dd9fd0a63110f8770dbf976be1c4",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "8.3333",
"displayValue": "$8.3333"
},
"annual_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"unit_net_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "8.3333",
"displayValue": "$8.3333"
},
"cumulative_annual_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "100.0000",
"displayValue": "$100.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_recurring_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "HOMEAUTOMA2000",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "d6792b8dd07a7910f8770dbf976be1f8",
"product_offering": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"cumulative_one_time_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"cumulative_monthly_recurring_price": {
"value": "60.0000",
"displayValue": "$60.00"
},
"cumulative_annual_recurring_price": {
"value": "720.0000",
"displayValue": "$720.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price_v1": {
"value": "60.0000",
"displayValue": "$60.00"
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
},
{
"line_id": "DOORSENSOR1001",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "10.0000",
"displayValue": "$10.00"
},
"list_price": {
"value": "10.0000",
"displayValue": "$10.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "3",
"price_list_line": "2ec2a745d07a7910f8770dbf976be159",
"product_offering": "fe5d203e11307110f877366201dea631",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "8.0000",
"displayValue": "$8.00"
},
"cumulative_net_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"cumulative_one_time_price": {
"value": "24.0000",
"displayValue": "$24.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-2.0000",
"displayValue": "($2.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -2.0,
"displayValue": "($2.00)"
},
"adjustment_amount_total": {
"value": -6.0,
"displayValue": "($6.00)"
},
"adjustment_description": {
"displayValue": "door sensor bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 8.0,
"displayValue": "$8.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -6.0,
"displayValue": "($6.00)"
}
]
},
{
"line_id": "HOMEAUTOMA1002",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"list_price": {
"value": "100.0000",
"displayValue": "$100.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "fe912705d07a7910f8770dbf976be147",
"product_offering": "3f6111dfd0a63110f8770dbf976be149",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_net_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_one_time_price": {
"value": "80.0000",
"displayValue": "$80.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-20.0000",
"displayValue": "($20.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -20.0,
"displayValue": "($20.00)"
},
"adjustment_amount_total": {
"value": -20.0,
"displayValue": "($20.00)"
},
"adjustment_description": {
"displayValue": "home automation hub bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 80.0,
"displayValue": "$80.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -20.0,
"displayValue": "($20.00)"
}
]
},
{
"line_id": "BASICMONIT1003",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "30.0000",
"displayValue": "$30.00"
},
"list_price": {
"value": "30.0000",
"displayValue": "$30.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "bc53e785d07a7910f8770dbf976be1e7",
"product_offering": "376111dfd0a63110f8770dbf976be140",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"annual_recurring_price": {
"value": "300.0000",
"displayValue": "$300.00"
},
"unit_net_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"cumulative_annual_recurring_price": {
"value": "300.0000",
"displayValue": "$300.00"
},
"unit_adjustment": {
"value": "-5.0000",
"displayValue": "($5.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "25.0000",
"displayValue": "$25.00"
},
"total_recurring_price": {
"value": "25.0000",
"displayValue": "$25.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "6e1c03d653dd91105c0eddeeff7b1232",
"displayValue": "MARKDOWN_AMT"
},
"adjustment_value": {
"value": 5.0,
"displayValue": "5"
},
"adjustment_amount": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_amount_total": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_description": {
"displayValue": "basic monitoring bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 25.0,
"displayValue": "$25.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -5.0,
"displayValue": "($5.00)"
}
]
},
{
"line_id": "PREMMONIT2004",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"list_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "a663a785d07a7910f8770dbf976be115",
"product_offering": "e2619d9fd0a63110f8770dbf976be1ec",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"annual_recurring_price": {
"value": "420.0000",
"displayValue": "$420.00"
},
"unit_net_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"cumulative_annual_recurring_price": {
"value": "420.0000",
"displayValue": "$420.00"
},
"unit_adjustment": {
"value": "-5.0000",
"displayValue": "($5.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": "35.0000",
"displayValue": "$35.00"
},
"total_recurring_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "6e1c03d653dd91105c0eddeeff7b1232",
"displayValue": "MARKDOWN_AMT"
},
"adjustment_value": {
"value": 5.0,
"displayValue": "5"
},
"adjustment_amount": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_amount_total": {
"value": -5.0,
"displayValue": "($5.00)"
},
"adjustment_description": {
"displayValue": "premium monitoring bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 35.0,
"displayValue": "$35.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -5.0,
"displayValue": "($5.00)"
}
]
},
{
"line_id": "INDOORCAM1006",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"list_price": {
"value": "35.0000",
"displayValue": "$35.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "81332f45d07a7910f8770dbf976be14e",
"product_offering": "1761dd9fd0a63110f8770dbf976be196",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_net_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_one_time_price": {
"value": "28.0000",
"displayValue": "$28.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-7.0000",
"displayValue": "($7.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -7.0,
"displayValue": "($7.00)"
},
"adjustment_amount_total": {
"value": -7.0,
"displayValue": "($7.00)"
},
"adjustment_description": {
"displayValue": "indoor camera bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 28.0,
"displayValue": "$28.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -7.0,
"displayValue": "($7.00)"
}
]
},
{
"line_id": "OUTCAMERA1007",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"list_price": {
"value": "40.0000",
"displayValue": "$40.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "1",
"price_list_line": "9a136f45d07a7910f8770dbf976be1b4",
"product_offering": "6f6111dfd0a63110f8770dbf976be100",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_net_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_one_time_price": {
"value": "32.0000",
"displayValue": "$32.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-8.0000",
"displayValue": "($8.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -8.0,
"displayValue": "($8.00)"
},
"adjustment_amount_total": {
"value": -8.0,
"displayValue": "($8.00)"
},
"adjustment_description": {
"displayValue": "outdoor camera bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 32.0,
"displayValue": "$32.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -8.0,
"displayValue": "($8.00)"
}
]
},
{
"line_id": "WINSENSOR1008",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "15.0000",
"displayValue": "$15.00"
},
"list_price": {
"value": "15.0000",
"displayValue": "$15.00"
},
"pricelist": "19d29513d0e63110f8770dbf976be122",
"quantity": "3",
"price_list_line": "91f26b45d07a7910f8770dbf976be19b",
"product_offering": "1b20347e11307110f877366201dea67f",
"parent_product_offer": "26d07c3211707110f877366201dea60c",
"top_product_offer": "26d07c3211707110f877366201dea60c",
"one_time_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "12.0000",
"displayValue": "$12.00"
},
"cumulative_net_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"cumulative_one_time_price": {
"value": "36.0000",
"displayValue": "$36.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "-3.0000",
"displayValue": "($3.00)"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [
{
"adjustment_type": {
"value": "a96c83d653dd91105c0eddeeff7b12d8",
"displayValue": "MARKDOWN_PER"
},
"adjustment_value": {
"value": 20.0,
"displayValue": "20"
},
"adjustment_amount": {
"value": -3.0,
"displayValue": "($3.00)"
},
"adjustment_amount_total": {
"value": -9.0,
"displayValue": "($9.00)"
},
"adjustment_description": {
"displayValue": "window sensor bundle discount"
},
"adjustment_sequence_id": {
"value": 1.0
},
"adjustment_matrix_type": {
"displayValue": "Configuration Component Price Adjustment"
},
"adjustment_basis": {
"value": "prv_price_point"
},
"price_point": {
"value": "net_price"
},
"pricing_plan_step": {
"value": "97b61272ffe722101fb14ad013cb14d7"
},
"running_price": {
"value": 12.0,
"displayValue": "$12.00"
}
}
],
"total_adjustment_amount": [
{
"pricePoint": "net_price",
"value": -9.0,
"displayValue": "($9.00)"
}
]
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "89.1666",
"displayValue": "$89.1666"
},
"total_monthly_recurring_price_v1": {
"value": "60.0000",
"displayValue": "$60.00"
},
"total_annual_recurring_price": {
"value": "1070.0000",
"displayValue": "$1,070.00"
},
"total_annual_recurring_price_v1": {
"value": "350.0000",
"displayValue": "$350.00"
},
"total_amount": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_amount_v1": {
"value": "610.0000",
"displayValue": "$610.00"
},
"total_one_time_price": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_monthly_margin": {
"value": "89.1666",
"displayValue": "$89.1666"
},
"total_margin_amount": {
"value": "200.0000",
"displayValue": "$200.00"
},
"total_one_time_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_monthly_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
},
"total_margin_percentage": {
"value": "100.0000",
"displayValue": "$100.00"
}
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS"
}
}
}
Resolução de ID externa
Este exemplo mostra a configuração do recurso de resolução de ID externa como verdadeiro ao definir o. lista de preços e. product_offering para uma variável mapeada personalizada chamada SENSOR1 .
"use_external_code": verdadeiro: Habilita a resolução de código externo"Lista de preços": "DOORSENSOR1": O valor é mapeado para uma variável de contexto personalizada para o preço"Product_Offering": "DOORSENSOR1": O valor é mapeado para uma variável de contexto personalizada para o produto
Exemplo: Solicitação curl.
curl "https://instance.servicenow.com/api/sn_csm_pricing/v1/pricingengine/computePrice" \
--request POST \
--header "Accept: application/json" \
--header "Content-Type: application/json" \
--data '{
"header": {
"source_system": "ServiceNow Headless API",
"requesting_record_id": "QT0001101",
"currency": "USD",
"lineItems": [
{
"pricelist": "DOORSENSOR1",
"product_offering": "DOORSENSOR1",
"periodicity" : "",
"quantity": "1",
"unit_of_measure": "cb2795d553020110286eddeeff7b12ff",
"transaction_date": "2023-12-18 23:37:11",
"line_id": "CONNECTEDC1100"
}
],
"pricelist": "19d29513d0e63110f8770dbf976be122",
"transaction_date": "2023-12-18 23:37:11"
},
"settings": {
"pricing_elements": "PRICE,COST,NET_PRICE,LINE_ROLLUPS,HEADER_ROLLUPS,ADJUSTMENTS",
"disable_validation": true,
"use_external_code": true
}
}' \
--user 'username:password'
{
"result": {
"header": {
"currency": "USD",
"lineItems": [
{
"line_id": "CONNECTEDC1100",
"status": "Success",
"currency": "USD",
"base_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"list_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricelist": "DOORSENSOR1",
"quantity": "",
"price_list_line": "3e93e785d07a7910f8770dbf976be1ee",
"product_offering": "DOORSENSOR1",
"one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_net_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"cumulative_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"unit_adjustment": {
"value": "0.0000",
"displayValue": "$0.00"
},
"term_month": {
"value": 0,
"displayValue": 0
},
"cumulative_annual_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"cumulative_monthly_recurring_price_v1": {
"value": 0,
"displayValue": 0
},
"total_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"pricingAdjustments": [],
"total_adjustment_amount": []
}
],
"status": "Success",
"total_monthly_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_annual_recurring_price_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_amount_v1": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_price": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_cost": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_amount": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_one_time_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_monthly_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
},
"total_margin_percentage": {
"value": "0.0000",
"displayValue": "$0.00"
}
},
"settings": {
[...]
